-- View: v_vatsum_raw
DROP VIEW v_vatsum2;
DROP VIEW v_vatsum_raw;


DROP VIEW v_cust_p_xanal;

DROP VIEW v_cust_p_hanal_no_x;
DROP VIEW v_cust_turnover;
DROP VIEW v_cust_total;
DROP VIEW v_cust_p_hanal;



DROP VIEW v_ixdetails;

CREATE OR REPLACE VIEW v_ixdetails AS 
(((((((( SELECT x0.doc_type, x0."location", x0.ac_location, x0.cust, x0.ref AS invoice_ref, 'Disposal' AS line_type, x0.line_number, x3.descr AS dept, x4.descr AS dept_group, x0.pdesc AS item_code, x1.desc1 AS description, x0.qty, '1899-12-31'::date AS date_out, '1899-12-31'::date AS date_in, 0::numeric AS time_charged, '' AS charge_period, x0.unit_sell, x0.goods, x0.vcode, x0.vrate, x0.vat
   FROM iddetail x0, pdesc x1, pdesc_ext x2, hire_dept x3, hire_dept_group x4
  WHERE x0.doc_type <> 'CR'::bpchar AND x0.pdesc = x1.cod AND x0.reg IS NULL AND x1.cod = x2.pdesc AND x2.dept_group = x4.nsuk AND x4.hire_dept = x3.nsuk
UNION 
 SELECT x5.doc_type, x5."location", x5.ac_location, x5.cust, x5.ref AS invoice_ref, 'Disposal' AS line_type, x5.line_number, x8.descr AS dept, x9.descr AS dept_group, x5.pdesc::text || x5.reg::text AS item_code, x6.desc1 AS description, x5.qty, '1899-12-31'::date AS date_out, '1899-12-31'::date AS date_in, 0::numeric AS time_charged, '' AS charge_period, x5.unit_sell, x5.goods, x5.vcode, x5.vrate, x5.vat
   FROM iddetail x5, pdesc x6, pdesc_ext x7, hire_dept x8, hire_dept_group x9
  WHERE x5.doc_type <> 'CR'::bpchar AND x5.pdesc = x6.cod AND x5.reg IS NOT NULL AND x6.cod = x7.pdesc AND x7.dept_group = x9.nsuk AND x9.hire_dept = x8.nsuk)
UNION 
 SELECT x10.doc_type, x10."location", x10.ac_location, x10.cust, x10.ref AS invoice_ref, 'Disposal' AS line_type, x10.line_number, x13.descr AS dept, x14.descr AS dept_group, x10.pdesc AS item_code, x11.desc1 AS description, x10.qty, '1899-12-31'::date AS date_out, '1899-12-31'::date AS date_in, 0::numeric AS time_charged, '' AS charge_period, 0::numeric - x10.unit_sell AS unit_sell, 0::numeric - x10.goods AS goods, x10.vcode, x10.vrate, 0::numeric - x10.vat AS vat
   FROM iddetail x10, pdesc x11, pdesc_ext x12, hire_dept x13, hire_dept_group x14
  WHERE x10.doc_type = 'CR'::bpchar AND x10.pdesc = x11.cod AND x10.reg IS NULL AND x11.cod = x12.pdesc AND x12.dept_group = x14.nsuk AND x14.hire_dept = x13.nsuk)
UNION 
 SELECT x15.doc_type, x15."location", x15.ac_location, x15.cust, x15.ref AS invoice_ref, 'Disposal' AS line_type, x15.line_number, x18.descr AS dept, x19.descr AS dept_group, x15.pdesc::text || x15.reg::text AS item_code, x16.desc1 AS description, x15.qty, '1899-12-31'::date AS date_out, '1899-12-31'::date AS date_in, 0::numeric AS time_charged, '' AS charge_period, 0::numeric - x15.unit_sell AS unit_sell, 0::numeric - x15.goods AS goods, x15.vcode, x15.vrate, 0::numeric - x15.vat AS vat
   FROM iddetail x15, pdesc x16, pdesc_ext x17, hire_dept x18, hire_dept_group x19
  WHERE x15.doc_type = 'CR'::bpchar AND x15.pdesc = x16.cod AND x15.reg IS NOT NULL AND x16.cod = x17.pdesc AND x17.dept_group = x19.nsuk AND x19.hire_dept = x18.nsuk)
UNION 
 SELECT x20.doc_type, x20."location", x20.ac_location, x20.cust, x20.ref AS invoice_ref, 'Sale' AS line_type, x20.line_number, x23.descr AS dept, x24.descr AS dept_group, x21.plu AS item_code, x21.descr AS description, x20.qty, '1899-12-31'::date AS date_out, '1899-12-31'::date AS date_in, 0::numeric AS time_charged, '' AS charge_period, x20.price AS unit_sell, x20.goods, x20.vcode, x20.vrate, x20.vat
   FROM iodetail x20, product_type x21, product x22, dept x23, dept_group x24
  WHERE x20.doc_type <> 'CR'::bpchar AND x20.product_type = x21.nsuk AND x21.product = x22.nsuk AND x22.dept_group = x24.nsuk AND x24.dept = x23.nsuk)
UNION 
 SELECT x25.doc_type, x25."location", x25.ac_location, x25.cust, x25.ref AS invoice_ref, 'Sale' AS line_type, x25.line_number, x28.descr AS dept, x29.descr AS dept_group, x26.plu AS item_code, x26.descr AS description, x25.qty, '1899-12-31'::date AS date_out, '1899-12-31'::date AS date_in, 0::numeric AS time_charged, '' AS charge_period, 0::numeric - x25.price AS unit_sell, 0::numeric - x25.goods AS goods, x25.vcode, x25.vrate, 0::numeric - x25.vat AS vat
   FROM iodetail x25, product_type x26, product x27, dept x28, dept_group x29
  WHERE x25.doc_type = 'CR'::bpchar AND x25.product_type = x26.nsuk AND x26.product = x27.nsuk AND x27.dept_group = x29.nsuk AND x29.dept = x28.nsuk)
UNION 
 SELECT x30.doc_type, x30."location", x30.ac_location, x30.cust, x30.ref AS invoice_ref, 'Rental' AS line_type, x30.line_number, x33.descr AS dept, x34.descr AS dept_group, x30.plant_desc::text || x30.plant_ref::text AS item_code, x31.desc1 AS description, x30.qty, x30.date_out, x30.date_in, x30.time_charged, x30.charge_period, x30.rate AS unit_sell, x30.goods, x30.vcode, x30.vrate, x30.vat
   FROM ihdetail x30, pdesc x31, pdesc_ext x32, hire_dept x33, hire_dept_group x34
  WHERE x30.doc_type <> 'CR'::bpchar AND x30.plant_desc = x31.cod AND x30.plant_ref IS NOT NULL AND x31.cod = x32.pdesc AND x32.dept_group = x34.nsuk AND x34.hire_dept = x33.nsuk)
UNION 
 SELECT x35.doc_type, x35."location", x35.ac_location, x35.cust, x35.ref AS invoice_ref, 'Rental' AS line_type, x35.line_number, x38.descr AS dept, x39.descr AS dept_group, x35.plant_desc AS item_code, x36.desc1 AS description, x35.qty, x35.date_out, x35.date_in, x35.time_charged, x35.charge_period, x35.rate AS unit_sell, x35.goods, x35.vcode, x35.vrate, x35.vat
   FROM ihdetail x35, pdesc x36, pdesc_ext x37, hire_dept x38, hire_dept_group x39
  WHERE x35.doc_type <> 'CR'::bpchar AND x35.plant_desc = x36.cod AND x35.plant_ref IS NULL AND x36.cod = x37.pdesc AND x37.dept_group = x39.nsuk AND x39.hire_dept = x38.nsuk)
UNION 
 SELECT x40.doc_type, x40."location", x40.ac_location, x40.cust, x40.ref AS invoice_ref, 'Rental' AS line_type, x40.line_number, x43.descr AS dept, x44.descr AS dept_group, x40.plant_desc::text || x40.plant_ref::text AS item_code, x41.desc1 AS description, x40.qty, x40.date_out, x40.date_in, x40.time_charged, x40.charge_period, 0::numeric - x40.rate AS unit_sell, 0::numeric - x40.goods AS goods, x40.vcode, x40.vrate, 0::numeric - x40.vat AS vat
   FROM ihdetail x40, pdesc x41, pdesc_ext x42, hire_dept x43, hire_dept_group x44
  WHERE x40.doc_type = 'CR'::bpchar AND x40.plant_desc = x41.cod AND x40.plant_ref IS NOT NULL AND x41.cod = x42.pdesc AND x42.dept_group = x44.nsuk AND x44.hire_dept = x43.nsuk)
UNION 
 SELECT x45.doc_type, x45."location", x45.ac_location, x45.cust, x45.ref AS invoice_ref, 'Rental' AS line_type, x45.line_number, x48.descr AS dept, x49.descr AS dept_group, x45.plant_desc AS item_code, x46.desc1 AS description, x45.qty, x45.date_out, x45.date_in, x45.time_charged, x45.charge_period, 0::numeric - x45.rate AS unit_sell, 0::numeric - x45.goods AS goods, x45.vcode, x45.vrate, 0::numeric - x45.vat AS vat
   FROM ihdetail x45, pdesc x46, pdesc_ext x47, hire_dept x48, hire_dept_group x49
  WHERE x45.doc_type = 'CR'::bpchar AND x45.plant_desc = x46.cod AND x45.plant_ref IS NULL AND x46.cod = x47.pdesc AND x47.dept_group = x49.nsuk AND x49.hire_dept = x48.nsuk;

ALTER TABLE v_ixdetails OWNER TO postgres;



CREATE OR REPLACE VIEW v_cust_p_hanal AS 
 SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
            ELSE ixd.goods
        END) AS amount, 0 AS qty
   FROM ihead ih, ihdetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
  GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_hanal OWNER TO postgres;



CREATE OR REPLACE VIEW v_cust_total AS 
( SELECT v_cust_p_hanal.ac_location, v_cust_p_hanal.cust, v_cust_p_hanal.period, sum(v_cust_p_hanal.amount) AS amount
   FROM v_cust_p_hanal
  GROUP BY v_cust_p_hanal.ac_location, v_cust_p_hanal.cust, v_cust_p_hanal.period
UNION ALL 
 SELECT v_cust_p_sanal.ac_location, v_cust_p_sanal.cust, v_cust_p_sanal.period, sum(v_cust_p_sanal.amount) AS amount
   FROM v_cust_p_sanal
  GROUP BY v_cust_p_sanal.ac_location, v_cust_p_sanal.cust, v_cust_p_sanal.period)
UNION ALL 
 SELECT v_cust_p_danal.ac_location, v_cust_p_danal.cust, v_cust_p_danal.period, sum(v_cust_p_danal.amount) AS amount
   FROM v_cust_p_danal
  GROUP BY v_cust_p_danal.ac_location, v_cust_p_danal.cust, v_cust_p_danal.period;

ALTER TABLE v_cust_total OWNER TO postgres;



CREATE OR REPLACE VIEW v_cust_turnover AS 
 SELECT v_cust_total.ac_location, v_cust_total.cust, v_cust_total.period, sum(v_cust_total.amount) AS amount
   FROM v_cust_total
  GROUP BY v_cust_total.ac_location, v_cust_total.cust, v_cust_total.period;

ALTER TABLE v_cust_turnover OWNER TO postgres;

CREATE OR REPLACE VIEW v_cust_p_hanal_no_x AS 
 SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
            ELSE ixd.goods
        END) AS amount, 0 AS qty
   FROM ihead ih, ihdetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust AND (ixd.plant_ref <> '9'::bpchar OR ixd.plant_ref IS NULL)
  GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_hanal_no_x OWNER TO postgres;

CREATE OR REPLACE VIEW v_cust_p_xanal AS 
 SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
            ELSE ixd.goods
        END) AS amount, 0 AS qty
   FROM ihead ih, ihdetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust AND ixd.plant_ref = '9'::bpchar
  GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_xanal OWNER TO postgres;






CREATE OR REPLACE VIEW v_vatsum_raw AS 
(((( SELECT pd.vcode AS cod, 'P' AS ledger, pl.typ AS trans, pd.goods, pd.vat, pl.period
   FROM pdetails pd, pledger pl
  WHERE pd.trans_ser = pl.ser
UNION ALL 
 SELECT ixd.vcode AS cod, 'S' AS ledger, 
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN 12
            ELSE 2
        END::smallint AS trans, ixd.goods, ixd.vat, ih.period
   FROM ihead ih, ihdetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust)
UNION ALL 
 SELECT ixd.vcode AS cod, 'S' AS ledger, 
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN 12
            ELSE 2
        END::smallint AS trans, ixd.goods, ixd.vat, ih.period
   FROM ihead ih, iodetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust)
UNION ALL 
 SELECT ixd.vcode AS cod, 'S' AS ledger, 
        CASE ih.doc_type
            WHEN 'CR'::bpchar THEN 12
            ELSE 2
        END::smallint AS trans, ixd.goods, ixd.vat, ih.period
   FROM ihead ih, iddetail ixd
  WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust)
UNION ALL 
 SELECT 1::smallint AS cod, 'S' AS ledger, sledger.typ AS trans, (sledger.amount - sledger.vat) * (-1)::numeric AS goods, sledger.vat * (-1)::numeric AS vat, sledger.period
   FROM sledger
  WHERE sledger.typ = 16 AND sledger.cod IS NOT NULL)
UNION ALL 
 SELECT 1::smallint AS cod, 'S' AS ledger, sledger.typ AS trans, (sledger.amount + sledger.vat) * (-1)::numeric AS goods, sledger.vat, sledger.period
   FROM sledger
  WHERE sledger.typ = 18 AND sledger.cod IS NOT NULL;

ALTER TABLE v_vatsum_raw OWNER TO postgres;

CREATE OR REPLACE VIEW v_vatsum2 AS 
 SELECT v.cod, v.ledger, v.trans, sum(v.goods) AS goods, sum(v.vat) AS vat, v.period
   FROM v_vatsum_raw v
  WHERE v.ledger = 'P'::text AND v.trans > 10 OR v.ledger = 'S'::text AND v.trans < 10
  GROUP BY v.cod, v.ledger, v.trans, v.period
UNION 
 SELECT v.cod, v.ledger, v.trans, sum(v.goods) * (-1)::numeric AS goods, sum(v.vat) * (-1)::numeric AS vat, v.period
   FROM v_vatsum_raw v
  WHERE v.ledger = 'P'::text AND v.trans < 10 OR v.ledger = 'S'::text AND v.trans > 10
  GROUP BY v.cod, v.ledger, v.trans, v.period;

ALTER TABLE v_vatsum2 OWNER TO postgres;