update useddocs set header_id = null where header_id not in (select nsuk from useddocs_head);
---ER TABLE useddocs ADD constraint foreign key (header_id)  REFERENCES useddocs_head(nsuk) CONSTRAINT useddocs_fk  ;
-- 1804 okay

update unmatched_history set supplier = null where supplier not in (select cod from supplier);
--ALTER TABLE unmatched_history ADD constraint foreign key (supplier)  REFERENCES supplier(cod)  CONSTRAINT unmatched_history_fk1 ;
-- 0 okay

update unmatched_history set pdesc = null where pdesc not in (select cod from pdesc);
-- 0 okay
ALTER TABLE unmatched_history ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod) CONSTRAINT unmatched_history_fk ;

update unmatched_history set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE unmatched ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT unmatched_fk1 ;

update unmatched set pdesc = null where pdesc not in (select cod from pdesc);
-- okay
ALTER TABLE unmatched ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod) CONSTRAINT unmatched_fk ;

update team_module set team = null where team not in (select nsuk from team);
-- 0 okay
ALTER TABLE team_module ADD constraint foreign key (team)  REFERENCES team(nsuk) CONSTRAINT team_module_fk ;

update team_menu set team = null where team not in (select nsuk from team);
-- 0 okay
ALTER TABLE team_menu ADD constraint foreign key (team)  REFERENCES team(nsuk) CONSTRAINT team_menu_fk ;

update team_member set team = null where team not in (select nsuk from team);
-- 0 okay
ALTER TABLE team_member ADD constraint foreign key (team)  REFERENCES team(nsuk) CONSTRAINT team_member_fk ;

update support_detail set nominal_code = null where nominal_code not in (select cod from nominal);
-- 0 okay
ALTER TABLE support_detail ADD constraint foreign key (nominal_code)  REFERENCES nominal(cod) CONSTRAINT support_detail_fk2 ;

update support_detail set vcode = 1 where vcode not in (select cod from vat);
-- 0 okay
ALTER TABLE support_detail ADD constraint foreign key (vcode)  REFERENCES vat(cod) CONSTRAINT support_detail_fk1 ;

delete from support_detail where support_ser not in (select nsuk from support);
-- 0 okay
ALTER TABLE support_detail ADD constraint foreign key (support_ser)  REFERENCES support(ser) CONSTRAINT support_detail_fk ;

update suppnotes set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE suppnotes ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT suppnotes_fk ;

update supplier_touched set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE supplier_touched ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT supplier_touched_fk ;

update supplier_terms set cod = null where cod not in (select cod from supplier);
-- 1 okay
ALTER TABLE supplier_terms ADD constraint foreign key (cod)  REFERENCES supplier(cod) CONSTRAINT supplier_terms_fk ;

delete from  supplier_group where slave not in (select cod from supplier);
-- 0 okay
ALTER TABLE supplier_group ADD constraint foreign key (slave)  REFERENCES supplier(cod) CONSTRAINT supplier_group_fk1 ;

delete from supplier_group where master not in (select cod from supplier);
-- 0 okay
ALTER TABLE supplier_group ADD constraint foreign key (master)  REFERENCES supplier(cod) CONSTRAINT supplier_group_fk ;

update supplier_ext set vatcode = 1 where vatcode not in (select cod from vat);
-- 9 There are 9 rows with cod = 0
ALTER TABLE supplier_ext ADD constraint foreign key (vatcode)  REFERENCES vat(cod) CONSTRAINT supplier_ext_fk2 ;

update supplier_ext set default_nominal = null where default_nominal not in (select cod from nominal);
-- 805 - There are 805 where is is spaces rather than null - there are some that are null
ALTER TABLE supplier_ext ADD constraint foreign key (default_nominal)  REFERENCES nominal(cod) CONSTRAINT supplier_ext_fk1 ;

delete from supplier_ext where cod not in (select cod from supplier);
-- 0 okay
ALTER TABLE supplier_ext ADD constraint foreign key (cod)  REFERENCES supplier(cod) CONSTRAINT supplier_ext_fk ;

update supplier set currency = 'EUR' where currency not in (select cod from currency);
-- 0 okay
ALTER TABLE supplier ADD constraint foreign key (currency)  REFERENCES currency(cod) CONSTRAINT supplier_fk1 ;

update supplier set credit_control = 'CREDIT' where credit_control not in (select cod from nominal);
-- 0 okay
--ALTER TABLE supplier ADD constraint foreign key (credit_control)  REFERENCES nominal(cod) CONSTRAINT supplier_fk ;

update stock_movement set supplier = null where supplier not in (select cod from supplier);
-- 76144 - okay - There are 84,000 nulls and 76144 spaces
ALTER TABLE stock_movement ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT stock_movement_fk5 ;

delete from  stock_movement where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE stock_movement ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT stock_movement_fk ;

update stock_freeze set nominal = null where nominal not in (select cod from nominal);
-- 0 okay
ALTER TABLE stock_freeze ADD constraint foreign key (nominal)  REFERENCES nominal(cod) CONSTRAINT stock_freeze_fk1 ;

update stock_freeze set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE stock_freeze ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT stock_freeze_fk ;

update stock_accrual set po_detail = null where po_detail not in (select nsuk from po_detail);
-- 0 okay
ALTER TABLE stock_accrual ADD constraint foreign key (po_detail)  REFERENCES po_detail(nsuk) CONSTRAINT stock_accrual_fk4 ;

update stock_accrual set nominal = null where nominal not in (select cod from nominal);
-- 0 okay
ALTER TABLE stock_accrual ADD constraint foreign key (nominal)  REFERENCES nominal(cod) CONSTRAINT stock_accrual_fk3 ;

update stock_accrual set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE stock_accrual ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT stock_accrual_fk2 ;

update stock set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE stock ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT stock_fk ;

update stk_take set stk_freeze_hdr_id = null where stk_freeze_hdr_id not in (select nsuk from stk_freeze_hdr);
-- 0 okay
ALTER TABLE stk_take ADD constraint foreign key (stk_freeze_hdr_id)  REFERENCES stk_freeze_hdr(nsuk) CONSTRAINT stk_take_fk ;

update stk_freeze_hdr set operator_id = 1 where operator_id not in (select cod from operator);
-- 0 okay
ALTER TABLE stk_freeze_hdr ADD constraint foreign key (operator_id)  REFERENCES operator(cod) CONSTRAINT stk_freeze_hdr_fk1 ;

update soq_xref set quotation = null where quotation not in (select nsuk from quote);
-- 0 okay
ALTER TABLE soq_xref ADD constraint foreign key (quotation)  REFERENCES quote(nsuk) CONSTRAINT soq_xref_fk ;

update so_head set quotation_number = null where quotation_number not in (select nsuk from quote);
-- 0 okay
ALTER TABLE so_head ADD constraint foreign key (quotation_number)  REFERENCES quote(nsuk) CONSTRAINT so_head_fk3 ;

update so_head set operator = 1 where operator not in (select cod from operator);
-- 0 okay
ALTER TABLE so_head ADD constraint foreign key (operator)  REFERENCES operator(cod) CONSTRAINT so_head_fk2 ;

--
-- Must set lodgement to a valid number else it will all be lodged again
--
select min(cod) minlodge from lodgement
into temp t_minlodge;
update sledger set lodgement = (select minlodge from t_minlodge)
where lodgement is not null and lodgement not in (select cod from lodgement);
-- 1 okay

ALTER TABLE sledger ADD constraint foreign key (lodgement)  REFERENCES lodgement(cod) CONSTRAINT sledger_fk2 ;

delete from  singles_ext where pdesc || cod not in (select pdesc || cod from singles);
-- 0 okay
ALTER TABLE singles_ext ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod) CONSTRAINT singles_ext_fk ;

delete from singles where pdesc not in (select  cod from pdesc);
-- 21 okay - checked pcost as well
ALTER TABLE singles ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod) CONSTRAINT singles_fk1 ;

delete from  scontact where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE scontact ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT scontact_fk ;

update sallocper set operator = 1 where operator not in (select cod from operator);
-- 0 okay
ALTER TABLE sallocper ADD constraint foreign key (operator)  REFERENCES operator(cod) CONSTRAINT sallocper_fk ;

delete  from sallocer where allocation not in (select allocation from sallocper);
-- 0 okay
ALTER TABLE sallocer ADD constraint foreign key (allocation)  REFERENCES sallocper(allocation) CONSTRAINT sallocer_fk ;

delete from sallocee where allocation not in (select allocation from sallocper);
-- 0 okay
ALTER TABLE sallocee ADD constraint foreign key (allocation)  REFERENCES sallocper(allocation) CONSTRAINT sallocee_fk ;

delete from salecr_stk_status where ihead_id not in (select nsuk from ihead);
-- 0 okay
ALTER TABLE salecr_stk_status ADD constraint foreign key (ihead_id)  REFERENCES ihead(nsuk) CONSTRAINT salecr_stk_status_fk ;

update s_ysales set dept = null where dept not in (select nsuk from dept);
-- 0 okay
ALTER TABLE s_ysales ADD constraint foreign key (dept)  REFERENCES dept(nsuk) CONSTRAINT s_ysales_fk1 ;

update s_ysales set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE s_ysales ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT s_ysales_fk ;

update s_wsales set dept = null where dept not in (select nsuk from dept);
-- 0 okay
ALTER TABLE s_wsales ADD constraint foreign key (dept)  REFERENCES dept(nsuk) CONSTRAINT s_wsales_fk1 ;

update s_wsales set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE s_wsales ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT s_wsales_fk ;

update s_msales set dept = null where dept not in (select nsuk from dept);
-- 0 okay
ALTER TABLE s_msales ADD constraint foreign key (dept)  REFERENCES dept(nsuk) CONSTRAINT s_msales_fk1 ;

update s_msales set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE s_msales ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT s_msales_fk ;

update rpt_dist_detail set contact = null where contact not in (select nsuk from contact);
-- 0 okay
ALTER TABLE rpt_dist_detail ADD constraint foreign key (contact)  REFERENCES contact(nsuk) CONSTRAINT rpt_dist_detail_fk1 ;

update rpt_dist_detail set distribution = null where distribution not in (select nsuk from rpt_distribution);
-- 0 okay
ALTER TABLE rpt_dist_detail ADD constraint foreign key (distribution)  REFERENCES rpt_distribution(nsuk) CONSTRAINT rpt_dist_detail_fk ;

update pt_ysales set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_ysales ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT pt_ysales_fk2 ;

update pt_ysales set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE pt_ysales ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT pt_ysales_fk1 ;

update pt_wsales set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_wsales ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT pt_wsales_fk2 ;

update pt_wsales set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE pt_wsales ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT pt_wsales_fk1 ;

update pt_supplier set currency = 'EUR' where currency not in (select cod from currency);
-- 0 okay
ALTER TABLE pt_supplier ADD constraint foreign key (currency)  REFERENCES currency(cod) CONSTRAINT pt_supplier_fk2 ;

update pt_supplier set supplier = 'DEFAUL' where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE pt_supplier ADD constraint foreign key (supplier)  REFERENCES supplier(cod) CONSTRAINT pt_supplier_fk1 ;

delete from pt_supplier where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_supplier ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT pt_supplier_fk ;

update pt_serial set io_detail = null where io_detail not in (select nsuk from iodetail);
-- 61 rows have a zero rather than a null
ALTER TABLE pt_serial ADD constraint foreign key (io_detail)  REFERENCES iodetail(nsuk) CONSTRAINT pt_serial_fk3 ;

update pt_serial set gi_detail = null where gi_detail not in (select nsuk from gi_detail);
-- 0 okay
ALTER TABLE pt_serial ADD constraint foreign key (gi_detail)  REFERENCES gi_detail(nsuk) CONSTRAINT pt_serial_fk1 ;

delete from  pt_serial where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_serial ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk) CONSTRAINT pt_serial_fk ;

delete from pt_part where part_name not in (select nsuk from part_name);
-- 0 okay
ALTER TABLE pt_part ADD constraint foreign key (part_name)  REFERENCES part_name(nsuk) CONSTRAINT pt_part_fk2 ;

delete from pt_part where part not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_part ADD constraint foreign key (part)  REFERENCES product_type(nsuk)       CONSTRAINT pt_part_fk1 ;

delete from pt_part where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_part ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)      CONSTRAINT pt_part_fk ;

delete from pt_option where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_option ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)       CONSTRAINT pt_option_fk ;

update pt_msales set sales_rep = 1 where sales_rep not in (select cod from operator);
-- 0 okay
ALTER TABLE pt_msales ADD constraint foreign key (sales_rep)  REFERENCES operator(cod)       CONSTRAINT pt_msales_fk3 ;

update pt_msales set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_msales ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)      CONSTRAINT pt_msales_fk2 ;

update pt_msales set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE pt_msales ADD constraint foreign key (supplier)  REFERENCES supplier(cod)       CONSTRAINT pt_msales_fk1 ;

delete from pt_bin_loc where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pt_bin_loc ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)      CONSTRAINT pt_bin_loc_fk ;

update pstock_history set asset_reg = null, pdesc = null where asset_reg || pdesc not in (select asset_reg || cod from pdesc);
-- 189 Okay
ALTER TABLE pstock_history ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT pstock_history_fk ;

delete from pstock where asset_reg || pdesc not in (select asset_reg || cod from pdesc);
-- 27 okay
ALTER TABLE pstock ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT pstock_fk ;

delete from psearch where supplier not in (select cod from supplier);
-- 3 okay
ALTER TABLE psearch ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT psearch_fk ;


update product_supplier set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE product_supplier ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT product_supplier_fk ;

update product set stock_nominal = null where stock_nominal not in (select cod from nominal);
-- 0 okay
ALTER TABLE product ADD constraint foreign key (stock_nominal)  REFERENCES nominal(cod)      CONSTRAINT product_fk6 ;

update product set dept_group = null where dept_group not in (select nsuk from dept_group);
-- 0 okay
ALTER TABLE product ADD constraint foreign key (dept_group)  REFERENCES dept_group(nsuk)      CONSTRAINT product_fk5 ;

update product set supplier = null where supplier not in (select cod from supplier);
-- 1 okay ??? Does a product have to have a supplier?
ALTER TABLE product ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT product_fk3 ;

update product set purchase_nominal = null where purchase_nominal not in (select cod from nominal);
-- 820 rows are set to 'CRAP'
ALTER TABLE product ADD constraint foreign key (purchase_nominal)  REFERENCES nominal(cod)      CONSTRAINT product_fk2 ;

update product set sales_nominal = null where sales_nominal not in (select cod from nominal);
-- 0 okay
ALTER TABLE product ADD constraint foreign key (sales_nominal)  REFERENCES nominal(cod)      CONSTRAINT product_fk1 ;

update product set vcode = 1 where vcode not in (select cod from vat);
-- 0 okay
ALTER TABLE product ADD constraint foreign key (vcode)  REFERENCES vat(cod)      CONSTRAINT product_fk ;

delete from  pricelist_det where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pricelist_det ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)      CONSTRAINT pricelist_det_fk1 ;

delete from pricelist_det where pricelist not in (select nsuk from pricelist);
-- 214 [TODO]
ALTER TABLE pricelist_det ADD constraint foreign key (pricelist)  REFERENCES pricelist(nsuk)      CONSTRAINT pricelist_det_fk ;

select nsuk from pricelist where parent not in (select nsuk from pricelist)
into temp noparent;
update pricelist set parent = null where nsuk in (select nsuk from noparent);

ALTER TABLE pricelist ADD constraint foreign key (parent)  REFERENCES pricelist(nsuk)      CONSTRAINT pricelist_fk ;

delete from price_det_hist where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE price_det_hist ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)      CONSTRAINT price_det_hist_fk1 ;

update pohanal set pdesc = null where pdesc not in (select cod from pdesc);
-- 188 [TODO] do we need RI
ALTER TABLE pohanal ADD constraint foreign key (pdesc)  REFERENCES pdesc(cod)      CONSTRAINT pohanal_fk1 ;

update po_head set status = 6 where status not in (select nsuk from po_status);  -- Cancelled
-- 0 okay
ALTER TABLE po_head ADD constraint foreign key (status)  REFERENCES po_status(nsuk)      CONSTRAINT po_head_fk5 ;

update po_head set currency = 'EUR' where currency not in (select cod from currency);
-- 0 okay
--ALTER TABLE po_head ADD constraint foreign key (currency)  REFERENCES currency(cod)      CONSTRAINT po_head_fk4 ;

update po_head set authorised_by = 1 where authorised_by not in (select cod from operator);
-- 0 okay
ALTER TABLE po_head ADD constraint foreign key (authorised_by)  REFERENCES operator(cod)      CONSTRAINT po_head_fk3 ;

update po_head set ordered_by = 1 where ordered_by not in (select cod from operator);
-- 0 okay
ALTER TABLE po_head ADD constraint foreign key (ordered_by)  REFERENCES operator(cod)      CONSTRAINT po_head_fk1 ;

--update po_head set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE po_head ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT po_head_fk ;

update po_detail set po_head = null where po_head not in (select nsuk from po_head);
-- 0 okay
ALTER TABLE po_detail ADD constraint foreign key (po_head)  REFERENCES po_head(nsuk)      CONSTRAINT po_detail_fk4 ;

update po_detail set vat = 1 where vat not in (select cod from vat);
-- 0 okay
ALTER TABLE po_detail ADD constraint foreign key (vat)  REFERENCES vat(cod)      CONSTRAINT po_detail_fk3 ;

update po_detail set asset_reg = null, pdesc = null where asset_reg || pdesc not in (select asset_reg || cod from pdesc);
-- 0 okay
ALTER TABLE po_detail ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT po_detail_fk2 ;

update po_detail set nominal = null where nominal not in (select cod from nominal);
-- 65 okay - all have nominal = spaces
ALTER TABLE po_detail ADD constraint foreign key (nominal)  REFERENCES nominal(cod)      CONSTRAINT po_detail_fk1 ;

update po_detail set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE po_detail ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)      CONSTRAINT po_detail_fk ;

update pmoves set operator = 1 where operator not in (select cod from operator);
-- 48 - okay there were 48 pointers to operator 13 which has been deleted
ALTER TABLE pmoves ADD constraint foreign key (operator)  REFERENCES operator(cod)      CONSTRAINT pmoves_fk3 ;

update pmoves set asset_reg = null, pdesc = null where asset_reg || pdesc not in (select asset_reg || cod from pdesc);
-- 0 okay
ALTER TABLE pmoves ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT pmoves_fk ;

delete from plnlxref where nltrans not in (select trans_no from nltrans);
-- 0 okay
ALTER TABLE plnlxref ADD constraint foreign key (nltrans)  REFERENCES nltrans(trans_no)      CONSTRAINT plnlxref_fk1 ;

delete from plnlxref where pledger not in (select ser from pledger);
-- 0 okay
ALTER TABLE plnlxref ADD constraint foreign key (pledger)  REFERENCES pledger(ser)      CONSTRAINT plnlxref_fk ;

delete from pledgerext where pledger_ser not in (select ser from pledger);
-- 0 okay
ALTER TABLE pledgerext ADD constraint foreign key (pledger_ser)  REFERENCES pledger(ser)      CONSTRAINT pledgerext_fk ;

update pledger set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE pledger ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT pledger_fk ;

update pi_head set entered_by = 1 where entered_by not in (select cod from operator);
-- 0 okay
ALTER TABLE pi_head ADD constraint foreign key (entered_by)  REFERENCES operator(cod)      CONSTRAINT pi_head_fk1 ;

update pi_head set supplier = null where supplier not in (select cod from supplier);
-- 0 okay
ALTER TABLE pi_head ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT pi_head_fk ;

update pi_detail set product_type = null where product_type not in (select nsuk from product_type);
-- 0 okay
ALTER TABLE pi_detail ADD constraint foreign key (product_type)  REFERENCES product_type(nsuk)      CONSTRAINT pi_detail_fk2 ;

update pi_detail set po_detail = null where po_detail not in (select nsuk from po_detail);
-- 29 okay
ALTER TABLE pi_detail ADD constraint foreign key (po_detail)  REFERENCES po_detail(nsuk)      CONSTRAINT pi_detail_fk1 ;

update pi_detail set pi_head = null where pi_head not in (select nsuk from pi_head);
-- 0 okay
ALTER TABLE pi_detail ADD constraint foreign key (pi_head)  REFERENCES pi_head(nsuk)      CONSTRAINT pi_detail_fk ;

update phistory set supp = null where supp not in (select cod from supplier);
-- 0 okay
ALTER TABLE phistory ADD constraint foreign key (supp)  REFERENCES supplier(cod)      CONSTRAINT phistory_fk3 ;

update phistory set asset_reg = 'H' where asset_reg not in (select asset_reg from pdesc);
-- - okay
update phistory set pdesc = null where pdesc not in (select cod from pdesc);
-- 291 okay
ALTER TABLE phistory ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT phistory_fk ;

update pdsearch set asset_reg = null where asset_reg not in (select asset_reg from pdesc);
-- 0 okay
update pdsearch set pdesc = null where pdesc not in (select cod from pdesc);
-- - okay
ALTER TABLE pdsearch ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT pdsearch_fk ;

update pdesc_ext set dept_group = null where dept_group not in (select nsuk from hire_dept_group);
-- 0 okay
ALTER TABLE pdesc_ext ADD constraint foreign key (dept_group)  REFERENCES hire_dept_group(nsuk)      CONSTRAINT pdesc_ext_fk1 ;

delete from pdesc_ext where pdesc not in (select cod from pdesc);
-- 0 okay
ALTER TABLE pdesc_ext ADD constraint foreign key (pdesc)  REFERENCES pdesc(cod)      CONSTRAINT pdesc_ext_fk ;

update pdesc set msg_typ = null where msg_typ not in (select msg_typ from pmsg);
-- 0 okay
ALTER TABLE pdesc ADD constraint foreign key (msg_typ)  REFERENCES pmsg(msg_typ)      CONSTRAINT pdesc_fk4 ;

update pdesc set vcode = 1 where vcode not in (select cod from vat);
-- 0 okay
ALTER TABLE pdesc ADD constraint foreign key (vcode)  REFERENCES vat(cod)      CONSTRAINT pdesc_fk3 ;

update pdesc set nominal = null where nominal not in (select cod from nominal);
-- 0 okay
ALTER TABLE pdesc ADD constraint foreign key (nominal)  REFERENCES nominal(cod)      CONSTRAINT pdesc_fk2 ;

update pcost_history set supplier = null where supplier not in (select cod from supplier);
ALTER TABLE pcost_history ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT pcost_history_fk1 ;

update pcost_history set asset_reg = 'H' where asset_reg not in (select asset_reg from pdesc);
update pcost_history set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE pcost_history ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT pcost_history_fk ;

update pcost set supplier = null where supplier not in (select cod from supplier);
ALTER TABLE pcost ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT pcost_fk1 ;

update pcost set asset_reg = 'H' where asset_reg not in (select asset_reg from pdesc);
update pcost set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE pcost ADD constraint foreign key (asset_reg, pdesc)  REFERENCES pdesc(asset_reg, cod)      CONSTRAINT pcost_fk ;

delete from pavail where pdesc not in (select cod from pdesc);
ALTER TABLE pavail ADD constraint foreign key (pdesc)  REFERENCES pdesc(cod)      CONSTRAINT pavail_fk ;

update pallocper set supplier = null where supplier not in (select cod from supplier);
ALTER TABLE pallocper ADD constraint foreign key (supplier)  REFERENCES supplier(cod)      CONSTRAINT pallocper_fk1 ;

update pallocper set operator = 1 where operator not in (select cod from operator);
ALTER TABLE pallocper ADD constraint foreign key (operator)  REFERENCES operator(cod)      CONSTRAINT pallocper_fk ;

update pallocer set er = null where er not in (select ser from pledger);
ALTER TABLE pallocer ADD constraint foreign key (er)  REFERENCES pledger(ser)      CONSTRAINT pallocer_fk1 ;

update pallocer set allocation = null where allocation not in (select allocation from pallocper);
ALTER TABLE pallocer ADD constraint foreign key (allocation)  REFERENCES pallocper(allocation)      CONSTRAINT pallocer_fk ;

update pallocee set ee = null where ee not in (select ser from pledger);
ALTER TABLE pallocee ADD constraint foreign key (ee)  REFERENCES pledger(ser)      CONSTRAINT pallocee_fk1 ;

update pallocee set allocation = null where allocation not in (select allocation from pallocper);
ALTER TABLE pallocee ADD constraint foreign key (allocation)  REFERENCES pallocper(allocation)      CONSTRAINT pallocee_fk ;

delete from nsearch where nominal not in (select cod from nominal);
ALTER TABLE nsearch ADD constraint foreign key (nominal)  REFERENCES nominal(cod)      CONSTRAINT nsearch_fk ;

update nparams set dep_accum = null where dep_accum not in (select cod from nominal);
ALTER TABLE nparams ADD constraint foreign key (dep_accum)  REFERENCES nominal(cod)      CONSTRAINT nparams_fk9 ;

update nparams set disposals = null where disposals not in (select cod from nominal);
ALTER TABLE nparams ADD constraint foreign key (disposals)  REFERENCES nominal(cod)      CONSTRAINT nparams_fk8 ;

update nparams set equipment = null where equipment not in (select cod from nominal);
ALTER TABLE nparams

 ADD constraint foreign key (equipment)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk7


  ;

update nparams set petty_cash = null where petty_cash not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (petty_cash)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk6


  ;

update nparams set retained = null where retained not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (retained)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk5


  ;

update nparams set vat = null where vat not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (vat)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk4


  ;

update nparams set disc_received = null where disc_received not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (disc_received)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk3


  ;

update nparams set disc_allowed = null where disc_allowed not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (disc_allowed)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk2


  ;

update nparams set equip_suspense = null where equip_suspense not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (equip_suspense)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk17


  ;

update nparams set bd_recovered = null where bd_recovered not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (bd_recovered)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk16


  ;

update nparams set bad_debts = null where bad_debts not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (bad_debts)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk15


  ;

update nparams set capital = null where capital not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (capital)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk14


  ;

update nparams set accruals = null where accruals not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (accruals)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk13


  ;

update nparams set plonex = null where plonex not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (plonex)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk12


  ;

update nparams set dep_expense = null where dep_expense not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (dep_expense)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk11


  ;

update nparams set plondisp = null where plondisp not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (plondisp)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk10


  ;

update nparams set creditors = null where creditors not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (creditors)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk1


  ;

update nparams set debtors = null where debtors not in (select cod from nominal);
ALTER TABLE nparams
 ADD constraint foreign key (debtors)
  REFERENCES nominal(cod)
  CONSTRAINT nparams_fk


  ;

update nominal set parent = null where cod = 'BALANC';
ALTER TABLE nominal
 ADD constraint foreign key (parent)
  REFERENCES nominal(cod)
  CONSTRAINT nominal_fk


  ;

update nltrans_hist set history_row = null where history_row not in (select ser from phistory);
ALTER TABLE nltrans_hist
 ADD constraint foreign key (history_row)
  REFERENCES phistory(ser)
  CONSTRAINT nltrans_hist_fk1


  ;

delete from nltrans_hist where trans_no not in (select trans_no from nltrans);
ALTER TABLE nltrans_hist
 ADD constraint foreign key (trans_no)
  REFERENCES nltrans(trans_no)
  CONSTRAINT nltrans_hist_fk


  ;

update nltrans_disp set disposal_row = null where disposal_row not in (select ser from disposals);
ALTER TABLE nltrans_disp
 ADD constraint foreign key (disposal_row)
  REFERENCES disposals(ser)
  CONSTRAINT nltrans_disp_fk1


  ;

delete from nltrans_disp where trans_no not in (select trans_no from nltrans);
ALTER TABLE nltrans_disp
 ADD constraint foreign key (trans_no)
  REFERENCES nltrans(trans_no)
  CONSTRAINT nltrans_disp_fk


  ;

-- Park this one until we sort out the t_nltrabs_shadow
--update nltrans set source = null, batch = null where source || batch not in (select source || seq from nlbatch);
--ALTER TABLE nltrans
-- ADD constraint foreign key (source, batch)
--  REFERENCES nlbatch(source, seq)
--  CONSTRAINT nltrans_fk3


--;

update nltrans set source = null where source not in (select cod from source);
ALTER TABLE nltrans
 ADD constraint foreign key (source)
  REFERENCES source(cod)
  CONSTRAINT nltrans_fk1


  ;

update nltrans set cod = null where cod not in (select cod from nominal);
ALTER TABLE nltrans
 ADD constraint foreign key (cod)
  REFERENCES nominal(cod)
  CONSTRAINT nltrans_fk


  ;

update nlbatch set source = null where source not in (select cod from source);
ALTER TABLE nlbatch
 ADD constraint foreign key (source)
  REFERENCES source(cod)
  CONSTRAINT nlbatch_fk


  ;
update lodgement set operator = 1 where operator not in (select cod from operator);
ALTER TABLE lodgement
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT lodgement_fk1


  ;

update journals set source = null, batch = null where source || batch not in (select source || seq from nlbatch);
ALTER TABLE journals
 ADD constraint foreign key (source, batch)
  REFERENCES nlbatch(source, seq)
  CONSTRAINT journals_fk3


  ;

update journals set operator = 1 where operator not in (select cod from operator);
ALTER TABLE journals
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT journals_fk2


  ;

update journals set source = null where source not in (select cod from source);
ALTER TABLE journals
 ADD constraint foreign key (source)
  REFERENCES source(cod)
  CONSTRAINT journals_fk


  ;

update ioh_sale set sales_rep = 1 where sales_rep not in (select cod from operator);
ALTER TABLE ioh_sale
 ADD constraint foreign key (sales_rep)
  REFERENCES operator(cod)
  CONSTRAINT ioh_sale_fk5


  ;

update ioh_sale set product_type = null where product_type not in (select nsuk from product_type);
ALTER TABLE ioh_sale
 ADD constraint foreign key (product_type)
  REFERENCES product_type(nsuk)
  CONSTRAINT ioh_sale_fk4


  ;

update ioh_sale set vcode = 1 where vcode not in (select cod from vat);
ALTER TABLE ioh_sale
 ADD constraint foreign key (vcode)
  REFERENCES vat(cod)
  CONSTRAINT ioh_sale_fk2


  ;

update ioh_sale set nominal = null where nominal not in (select cod from nominal);
ALTER TABLE ioh_sale
 ADD constraint foreign key (nominal)
  REFERENCES nominal(cod)
  CONSTRAINT ioh_sale_fk1


  ;

update ioh_hire set sales_rep = 1 where sales_rep not in (select cod from operator);
ALTER TABLE ioh_hire
 ADD constraint foreign key (sales_rep)
  REFERENCES operator(cod)
  CONSTRAINT ioh_hire_fk4


  ;

update ioh_hire set nominal = null where nominal not in (select cod from nominal);
ALTER TABLE ioh_hire
 ADD constraint foreign key (nominal)
  REFERENCES nominal(cod)
  CONSTRAINT ioh_hire_fk3


  ;

update ioh_hire set vcode = 1 where vcode not in (select cod from vat);
ALTER TABLE ioh_hire
 ADD constraint foreign key (vcode)
  REFERENCES vat(cod)
  CONSTRAINT ioh_hire_fk2


  ;

update ioh_hire set plant_desc = null where plant_desc not in (select cod from pdesc);
ALTER TABLE ioh_hire
 ADD constraint foreign key (plant_desc)
  REFERENCES pdesc(cod)
  CONSTRAINT ioh_hire_fk1


  ;

update ioh_disp set sales_rep = 1 where sales_rep not in (select cod from operator);
ALTER TABLE ioh_disp
 ADD constraint foreign key (sales_rep)
  REFERENCES operator(cod)
  CONSTRAINT ioh_disp_fk5


  ;

update ioh_disp set nominal = null where nominal not in (select cod from nominal);
ALTER TABLE ioh_disp
 ADD constraint foreign key (nominal)
  REFERENCES nominal(cod)
  CONSTRAINT ioh_disp_fk3


  ;

update ioh_disp set vcode = 1 where vcode not in (select cod from vat);
ALTER TABLE ioh_disp
 ADD constraint foreign key (vcode)
  REFERENCES vat(cod)
  CONSTRAINT ioh_disp_fk2


  ;

update ioh_disp set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE ioh_disp
 ADD constraint foreign key (asset_reg, pdesc)
  REFERENCES pdesc(asset_reg, cod)
  CONSTRAINT ioh_disp_fk1


  ;

update iodetail set vcode = 1 where vcode not in (select cod from vat);
ALTER TABLE iodetail
 ADD constraint foreign key (vcode)
  REFERENCES vat(cod)
  CONSTRAINT iodetail_fk3


  ;

update iodetail set nominal = null where nominal not in (select cod from nominal);
ALTER TABLE iodetail
 ADD constraint foreign key (nominal)
  REFERENCES nominal(cod)
  CONSTRAINT iodetail_fk2


  ;

update iodetail set product_type = null where product_type not in (select nsuk from product_type);
ALTER TABLE iodetail
 ADD constraint foreign key (product_type)
  REFERENCES product_type(nsuk)
  CONSTRAINT iodetail_fk1


  ;
--
-- Maybe do this is 4gl
--

--delete from  iodetail where doc_type || location || iodetail.ref || cust
--not in (select doc_type || location || iodetail.ref || cust from ihead);
--ALTER TABLE iodetail
--ADD constraint foreign key (doc_type, location, ref, cust)
--REFERENCES ihead(doc_type, location, ref, cust)
--CONSTRAINT iodetail_fk


--;

update ihead set sales_rep = 1 where sales_rep not in (select cod from operator);
ALTER TABLE ihead
 ADD constraint foreign key (sales_rep)
  REFERENCES operator(cod)
  CONSTRAINT ihead_fk2


  ;

update ihead set operator = 1 where operator not in (select cod from operator);
ALTER TABLE ihead
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT ihead_fk1


  ;

update ihdetail set plant_desc = null where plant_desc not in (select cod from pdesc);
ALTER TABLE ihdetail
 ADD constraint foreign key (plant_desc)
  REFERENCES pdesc(cod)
  CONSTRAINT ihdetail_fk5


  ;

update ihdetail set vcode = 1 where vcode not in (select cod from vat);
ALTER TABLE ihdetail
 ADD constraint foreign key (vcode)
  REFERENCES vat(cod)
  CONSTRAINT ihdetail_fk4


  ;

update ihdetail set nominal = null where nominal not in (select cod from nominal);
ALTER TABLE ihdetail
 ADD constraint foreign key (nominal)
  REFERENCES nominal(cod)
  CONSTRAINT ihdetail_fk3


  ;

--
-- Maybe do this is 4gl
--
--delete from ihdetail where doc_type || location || ihdetail.ref || cust
--not in (select doc_type || location || ihdetail.ref || cust from ihead);
--ALTER TABLE ihdetail
-- ADD constraint foreign key (doc_type, location, ref, cust)
--  REFERENCES ihead(doc_type, location, ref, cust)
--  CONSTRAINT ihdetail_fk


--  ;

update iddetail set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE iddetail
 ADD constraint foreign key (asset_reg, pdesc)
  REFERENCES pdesc(asset_reg, cod)
  CONSTRAINT iddetail_fk5


  ;

update iddetail set vcode = 1 where vcode not in (select cod from vat);
ALTER TABLE iddetail
 ADD constraint foreign key (vcode)
  REFERENCES vat(cod)
  CONSTRAINT iddetail_fk2


  ;

update iddetail set nominal = null where nominal not in (select cod from nominal);
ALTER TABLE iddetail
 ADD constraint foreign key (nominal)
  REFERENCES nominal(cod)
  CONSTRAINT iddetail_fk1


  ;
--
-- Maybe do this is 4gl
--

--delete from iddetail where doc_type || location || iddetail.ref || cust
--not in (select doc_type || location || iddetail.ref || cust from ihead);
--ALTER TABLE iddetail
-- ADD constraint foreign key (doc_type, location, ref, cust)
--  REFERENCES ihead(doc_type, location, ref, cust)
--  CONSTRAINT iddetail_fk


  --;

delete from hrates where tender not in (select cod from tender);
ALTER TABLE hrates
 ADD constraint foreign key (tender)
  REFERENCES tender(cod)
  CONSTRAINT hrates_fk1


  ;

delete from hrates where pdesc not in (select cod from pdesc);
ALTER TABLE hrates
 ADD constraint foreign key (pdesc)
  REFERENCES pdesc(cod)
  CONSTRAINT hrates_fk


  ;

update hmhead set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE hmhead
 ADD constraint foreign key (asset_reg, pdesc)
  REFERENCES pdesc(asset_reg, cod)
  CONSTRAINT hmhead_fk4


  ;

update hmhead set driver = 1 where driver not in (select cod from operator);
ALTER TABLE hmhead
 ADD constraint foreign key (driver)
  REFERENCES driver(nsuk)
  CONSTRAINT hmhead_fk3


  ;

update hmhead set operator = 1 where operator not in (select cod from operator);
ALTER TABLE hmhead
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT hmhead_fk1


  ;

delete from  hire_dept_group where hire_dept not in (select nsuk from hire_dept);
ALTER TABLE hire_dept_group
 ADD constraint foreign key (hire_dept)
  REFERENCES hire_dept(nsuk)
  CONSTRAINT hire_dept_group_fk


  ;

update gi_head set inspected_by = 1 where inspected_by not in (select cod from operator);
ALTER TABLE gi_head
 ADD constraint foreign key (inspected_by)
  REFERENCES operator(cod)
  CONSTRAINT gi_head_fk3


  ;

update gi_head set operator = 1 where operator not in (select cod from operator);
ALTER TABLE gi_head
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT gi_head_fk1


  ;

update gi_head set supplier = null where supplier not in (select cod from supplier);
ALTER TABLE gi_head
 ADD constraint foreign key (supplier)
  REFERENCES supplier(cod)
  CONSTRAINT gi_head_fk


  ;

update gi_detail set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE gi_detail
 ADD constraint foreign key (asset_reg, pdesc)
  REFERENCES pdesc(asset_reg, cod)
  CONSTRAINT gi_detail_fk6


  ;

update gi_detail set pi_detail = null where pi_detail not in (select nsuk from pi_detail);
ALTER TABLE gi_detail
 ADD constraint foreign key (pi_detail)
  REFERENCES pi_detail(nsuk)
  CONSTRAINT gi_detail_fk4


  ;

update gi_detail set cc_detail = null where cc_detail not in (select nsuk from cc_detail);
ALTER TABLE gi_detail
 ADD constraint foreign key (cc_detail)
  REFERENCES cc_detail(nsuk)
  CONSTRAINT gi_detail_fk3


  ;

update gi_detail set po_detail = null where po_detail not in (select nsuk from po_detail);
ALTER TABLE gi_detail
 ADD constraint foreign key (po_detail)
  REFERENCES po_detail(nsuk)
  CONSTRAINT gi_detail_fk2


  ;

update gi_detail set product_type = null where product_type not in (select nsuk from product_type);
ALTER TABLE gi_detail
 ADD constraint foreign key (product_type)
  REFERENCES product_type(nsuk)
  CONSTRAINT gi_detail_fk1


  ;

--update gi_detail set gi_head = null where gi_head not in (select nsuk from gi_head);
--ALTER TABLE gi_detail
 --ADD constraint foreign key (gi_head)
  --REFERENCES gi_head(nsuk)
  --CONSTRAINT gi_detail_fk


--  ;

-- Is this really nsuk or cod

update g_ysales set dept = null where dept not in (select nsuk from dept);
ALTER TABLE g_ysales
 ADD constraint foreign key (dept)
  REFERENCES dept(nsuk)
  CONSTRAINT g_ysales_fk1


  ;

update g_ysales set dept_group = null where dept_group not in (select nsuk from dept_group);
ALTER TABLE g_ysales
 ADD constraint foreign key (dept_group)
  REFERENCES dept_group(nsuk)
  CONSTRAINT g_ysales_fk


  ;

update g_wsales set dept = null where dept not in (select nsuk from dept);
ALTER TABLE g_wsales
 ADD constraint foreign key (dept)
  REFERENCES dept(nsuk)
  CONSTRAINT g_wsales_fk1


  ;

update g_wsales set dept_group = null where dept_group not in (select nsuk from dept_group);
ALTER TABLE g_wsales
 ADD constraint foreign key (dept_group)
  REFERENCES dept_group(nsuk)
  CONSTRAINT g_wsales_fk


  ;

update g_msales set dept = null where dept not in (select nsuk from dept);
ALTER TABLE g_msales
 ADD constraint foreign key (dept)
  REFERENCES dept(nsuk)
  CONSTRAINT g_msales_fk1


  ;

update g_msales set dept_group = null where dept_group not in (select nsuk from dept_group);
ALTER TABLE g_msales
 ADD constraint foreign key (dept_group)
  REFERENCES dept_group(nsuk)
  CONSTRAINT g_msales_fk


  ;

update freeze_gid set gi_detail = null where gi_detail not in (select nsuk from gi_detail);
ALTER TABLE freeze_gid
 ADD constraint foreign key (gi_detail)
  REFERENCES gi_detail(nsuk)
  CONSTRAINT freeze_gid_fk


  ;

update driver set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE driver
 ADD constraint foreign key (asset_reg, pdesc)
  REFERENCES pdesc(asset_reg, cod)
  CONSTRAINT driver_fk1


  ;

delete from dispxref where disposal not in (select ser from disposals);
ALTER TABLE dispxref
 ADD constraint foreign key (disposal)
  REFERENCES disposals(ser)
  CONSTRAINT dispxref_fk1


  ;


update disposals set disposal_type = 1 where disposal_type not in (select cod from disptypes); -- scrapped
ALTER TABLE disposals
 ADD constraint foreign key (disposal_type)
  REFERENCES disptypes(cod)
  CONSTRAINT disposals_fk4


  ;
update disposals set pdesc = null where pdesc not in (select cod from pdesc);
ALTER TABLE disposals
 ADD constraint foreign key (asset_reg, pdesc)
  REFERENCES pdesc(asset_reg, cod)
  CONSTRAINT disposals_fk1


  ;

delete from disc_detail where dept_group not in (select nsuk from dept_group);
ALTER TABLE disc_detail
 ADD constraint foreign key (dept_group)
  REFERENCES dept_group(nsuk)
  CONSTRAINT disc_detail_fk2


  ;

delete from disc_detail where department not in (select nsuk from dept);
ALTER TABLE disc_detail
 ADD constraint foreign key (department)
  REFERENCES dept(nsuk)
  CONSTRAINT disc_detail_fk1


  ;

delete from  disc_detail where disc_struct not in (select nsuk from disc_struct);
ALTER TABLE disc_detail
 ADD constraint foreign key (disc_struct)
  REFERENCES disc_struct(nsuk)
  CONSTRAINT disc_detail_fk


  ;

delete from dept_group where dept not in (select nsuk from dept);
ALTER TABLE dept_group
 ADD constraint foreign key (dept)
  REFERENCES dept(nsuk)
  CONSTRAINT dept_group_fk


  ;

--update depot set acdepot = null where yyyyyy not in (select nsuk from aaaaaa);
ALTER TABLE depot
 ADD constraint foreign key (acdepot)
  REFERENCES depot(cod)
  CONSTRAINT depot_fk1


  ;

update depot set cost_centre = null where cost_centre not in (select cod from ccentre);
ALTER TABLE depot
 ADD constraint foreign key (cost_centre)
  REFERENCES ccentre(cod)
  CONSTRAINT depot_fk


  ;

update d_ysales set dept = null where dept not in (select nsuk from dept);
ALTER TABLE d_ysales
 ADD constraint foreign key (dept)
  REFERENCES dept(nsuk)
  CONSTRAINT d_ysales_fk


  ;

update d_wsales set dept = null where dept not in (select nsuk from dept);
ALTER TABLE d_wsales
 ADD constraint foreign key (dept)
  REFERENCES dept(nsuk)
  CONSTRAINT d_wsales_fk


  ;

update d_msales set dept = null where dept not in (select nsuk from dept);
ALTER TABLE d_msales
 ADD constraint foreign key (dept)
  REFERENCES dept(nsuk)
  CONSTRAINT d_msales_fk


  ;

delete from cust_pricelist where pricelist not in (select nsuk from pricelist);
ALTER TABLE cust_pricelist
 ADD constraint foreign key (pricelist)
  REFERENCES pricelist(nsuk)
  CONSTRAINT cust_pricelist_fk1


  ;

update cust_order set operator = null where operator not in (select nsuk from operator);
ALTER TABLE cust_order
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT cust_order_fk9


  ;

update cust_order set sales_rep = 1 where sales_rep not in (select cod from operator);
ALTER TABLE cust_order
 ADD constraint foreign key (sales_rep)
  REFERENCES operator(cod)
  CONSTRAINT cust_order_fk8


  ;

update cust_order set quotation = null where quotation not in (select nsuk from quote);
ALTER TABLE cust_order
 ADD constraint foreign key (quotation)
  REFERENCES quote(nsuk)
  CONSTRAINT cust_order_fk7


  ;

update cust_order set policy = 'NORMAL' where policy not in (select nam from policy);
ALTER TABLE cust_order
 ADD constraint foreign key (policy)
  REFERENCES policy(nam)
  CONSTRAINT cust_order_fk6


  ;

update cust_order set discount_structure = null where discount_structure not in (select nsuk from disc_struct);
ALTER TABLE cust_order
 ADD constraint foreign key (discount_structure)
  REFERENCES disc_struct(nsuk)
  CONSTRAINT cust_order_fk5


  ;

update cust_order set price_list = null where price_list not in (select nsuk from pricelist);
ALTER TABLE cust_order
 ADD constraint foreign key (price_list)
  REFERENCES pricelist(nsuk)
  CONSTRAINT cust_order_fk4


  ;

update cust_order set site = null where depot || customer || site not in (select depot || cust || site from custsite);
ALTER TABLE cust_order
 ADD constraint foreign key (depot, customer, site)
  REFERENCES custsite(depot, cust, site)
  CONSTRAINT cust_order_fk3


  ;

update cust_order set customer_contact = null where customer_contact not in (select nsuk from contact);
ALTER TABLE cust_order
 ADD constraint foreign key (customer_contact)
  REFERENCES contact(nsuk)
  CONSTRAINT cust_order_fk2


  ;

update cust_ext set vatcode = 1 where vatcode not in (select cod from vat);
ALTER TABLE cust_ext
 ADD constraint foreign key (vatcode)
  REFERENCES vat(cod)
  CONSTRAINT cust_ext_fk3


  ;

update cust_ext set credit_controller = 1 where credit_controller not in (select cod from operator);
ALTER TABLE cust_ext
 ADD constraint foreign key (credit_controller)
  REFERENCES operator(cod)
  CONSTRAINT cust_ext_fk2


  ;

update cust_ext set sales_rep = 1 where sales_rep not in (select cod from operator);
ALTER TABLE cust_ext
 ADD constraint foreign key (sales_rep)
  REFERENCES operator(cod)
  CONSTRAINT cust_ext_fk1


  ;

delete from cust_discstruct where disc_struct not in (select nsuk from disc_struct);
ALTER TABLE cust_discstruct
 ADD constraint foreign key (disc_struct)
  REFERENCES disc_struct(nsuk)
  CONSTRAINT cust_discstruct_fk1


  ;

update cust set operator = 1 where operator not in (select cod from operator);
ALTER TABLE cust
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT cust_fk5


  ;

--update cust set tender = null where tender not in (select cod from tender);
--ALTER TABLE cust
-- ADD constraint foreign key (tender)
--  REFERENCES tender(cod)
--  CONSTRAINT cust_fk3


--  ;

--update cust set policy = 'NORMAL' where policy not in (select cod from policy);
--ALTER TABLE cust
-- ADD constraint foreign key (policy)
--  REFERENCES policy(nam)
--  CONSTRAINT cust_fk2


--  ;

--update cust set cust_status_id = null where cust_status_id not in (select nsuk from cust_status);
--ALTER TABLE cust
 --ADD constraint foreign key (cust_status_id)
  --REFERENCES cust_status(nsuk)
  --CONSTRAINT cust_fk


--  ;

update csuspend set operator = 1 where operator not in (select cod from operator);
ALTER TABLE csuspend
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT csuspend_fk1


  ;

update cr_activity set act_typ = null where act_typ not in (select typ from cr_typ);
ALTER TABLE cr_activity
 ADD constraint foreign key (act_typ)
  REFERENCES cr_typ(typ)
  CONSTRAINT cr_activity_fk


  ;

update contract_suspend set operator = 1 where operator not in (select cod from operator);
ALTER TABLE contract_suspend
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT contract_suspend_fk1


  ;

update contact set typ = null where typ not in (select cod from contact_type);
ALTER TABLE contact
 ADD constraint foreign key (typ)
  REFERENCES contact_type(cod)
  CONSTRAINT contact_fk


  ;

update codetail set vcode = 1 where vcode not in (select cod from vat);
ALTER TABLE codetail
 ADD constraint foreign key (vcode)
  REFERENCES vat(cod)
  CONSTRAINT codetail_fk3


  ;

update codetail set operator = 1 where operator not in (select cod from operator);
ALTER TABLE codetail
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT codetail_fk2


  ;

update codetail set product_type = null where product_type not in (select nsuk from product_type);
ALTER TABLE codetail
 ADD constraint foreign key (product_type)
  REFERENCES product_type(nsuk)
  CONSTRAINT codetail_fk


  ;

update cod_allocation set pt_serial = null where pt_serial not in (select nsuk from pt_serial);
ALTER TABLE cod_allocation
 ADD constraint foreign key (pt_serial)
  REFERENCES pt_serial(nsuk)
  CONSTRAINT cod_allocation_fk2


  ;

update cod_allocation set gidetail = null where gidetail not in (select nsuk from gi_detail);
ALTER TABLE cod_allocation
 ADD constraint foreign key (gidetail)
  REFERENCES gi_detail(nsuk)
  CONSTRAINT cod_allocation_fk1


  ;

delete from cod_allocation where location || contract || lin not in (select location || contract || lin from codetail);
ALTER TABLE cod_allocation
 ADD constraint foreign key (location, contract, lin)
  REFERENCES codetail(location, contract, lin)
  CONSTRAINT cod_allocation_fk


  ;

delete from cn_pid_xref where cndetail not in (select nsuk from cn_detail);
ALTER TABLE cn_pid_xref
 ADD constraint foreign key (cndetail)
  REFERENCES cn_detail(nsuk)
  CONSTRAINT cn_pid_xref_fk2


  ;

update cn_pid_xref set ccdetail = null where ccdetail not in (select nsuk from cc_detail);
ALTER TABLE cn_pid_xref
 ADD constraint foreign key (ccdetail)
  REFERENCES cc_detail(nsuk)
  CONSTRAINT cn_pid_xref_fk1


  ;

update cn_pid_xref set pidetail = null where pidetail not in (select nsuk from pi_detail);
ALTER TABLE cn_pid_xref
 ADD constraint foreign key (pidetail)
  REFERENCES pi_detail(nsuk)
  CONSTRAINT cn_pid_xref_fk


  ;

update cn_head set entered_by = 1 where entered_by not in (select cod from operator);
ALTER TABLE cn_head
 ADD constraint foreign key (entered_by)
  REFERENCES operator(cod)
  CONSTRAINT cn_head_fk2


  ;

update cn_head set pledger_ser = null where pledger_ser not in (select ser from pledger);
ALTER TABLE cn_head
 ADD constraint foreign key (pledger_ser)
  REFERENCES pledger(ser)
  CONSTRAINT cn_head_fk1


  ;

update cn_head set supplier = null where supplier not in (select cod from supplier);
ALTER TABLE cn_head
 ADD constraint foreign key (supplier)
  REFERENCES supplier(cod)
  CONSTRAINT cn_head_fk


  ;

update cn_detail set vat_code = null where vat_code not in (select cod from vat);
ALTER TABLE cn_detail
 ADD constraint foreign key (vat_code)
  REFERENCES vat(cod)
  CONSTRAINT cn_detail_fk4


  ;

update cn_detail set product_type = null where product_type not in (select nsuk from product_type);
ALTER TABLE cn_detail
 ADD constraint foreign key (product_type)
  REFERENCES product_type(nsuk)
  CONSTRAINT cn_detail_fk3


  ;

update cn_detail set cc_detail = null where cc_detail not in (select nsuk from cc_detail);
ALTER TABLE cn_detail
 ADD constraint foreign key (cc_detail)
  REFERENCES cc_detail(nsuk)
  CONSTRAINT cn_detail_fk2


  ;

update cn_detail set pi_detail = null where pi_detail not in (select nsuk from pi_detail);
ALTER TABLE cn_detail
 ADD constraint foreign key (pi_detail)
  REFERENCES pi_detail(nsuk)
  CONSTRAINT cn_detail_fk1


  ;

update cn_detail set cn_head = null where cn_head not in (select nsuk from cn_head);
ALTER TABLE cn_detail
 ADD constraint foreign key (cn_head)
  REFERENCES cn_head(nsuk)
  CONSTRAINT cn_detail_fk


  ;

update cheque_xref set ledger = null where ledger not in (select ser from pledger);
ALTER TABLE cheque_xref
 ADD constraint foreign key (ledger)
  REFERENCES pledger(ser)
  CONSTRAINT cheque_xref_fk


  ;

update chead set tender = 'STANDARD' where tender not in (select cod from tender);
ALTER TABLE chead
 ADD constraint foreign key (tender)
  REFERENCES tender(cod)
  CONSTRAINT chead_fk3


  ;

update chead set site = null where depot || cust || site not in (select depot || cust || site from custsite);
ALTER TABLE chead
 ADD constraint foreign key (depot, cust, site)
  REFERENCES custsite(depot, cust, site)
  CONSTRAINT chead_fk2


  ;

update chead set operator = 1 where operator not in (select cod from operator);
ALTER TABLE chead
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT chead_fk1


  ;

update chdetailext set charge_line = null where charge_line not in (select nsuk from charge_lines);
ALTER TABLE chdetailext
 ADD constraint foreign key (charge_line)
  REFERENCES charge_lines(nsuk)
  CONSTRAINT chdetailext_fk1


  ;

delete from chdetailext where location || contract || lin  not in (select location || contract || lin  from chdetail);
ALTER TABLE chdetailext
 ADD constraint foreign key (location, contract, lin)
  REFERENCES chdetail(location, contract, lin)
  CONSTRAINT chdetailext_fk


  ;

update chdetail set operator = 1 where operator not in (select cod from operator);
ALTER TABLE chdetail
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT chdetail_fk2


  ;

delete from chdetail where location || contract not in (select location || contract from chead);
ALTER TABLE chdetail
 ADD constraint foreign key (location, contract)
  REFERENCES chead(location, contract)
  CONSTRAINT chdetail_fk


  ;

delete from cdisposal where location || contract not in (select location || contract from chead);
ALTER TABLE cdisposal
 ADD constraint foreign key (location, contract)
  REFERENCES chead(location, contract)
  CONSTRAINT cdisposal_fk


  ;

update cc_head set contact = null where contact not in (select nsuk from scontact);
ALTER TABLE cc_head
 ADD constraint foreign key (contact)
  REFERENCES scontact(nsuk)
  CONSTRAINT cc_head_fk5


  ;

update cc_head set entered_by = 1 where entered_by not in (select cod from operator);
ALTER TABLE cc_head
 ADD constraint foreign key (entered_by)
  REFERENCES operator(cod)
  CONSTRAINT cc_head_fk3


  ;

update cc_head set supplier = null where supplier not in (select cod from supplier);
ALTER TABLE cc_head
 ADD constraint foreign key (supplier)
  REFERENCES supplier(cod)
  CONSTRAINT cc_head_fk2


  ;

--update cc_head set contact = null where contact not in (select nsuk from scontact);
--ALTER TABLE cc_head
 --ADD constraint foreign key (contact)
  --REFERENCES scontact(nsuk)
  --CONSTRAINT cc_head_fk1


  --;

update cc_head set status = null where status not in (select nsuk from cc_status);
ALTER TABLE cc_head
 ADD constraint foreign key (status)
  REFERENCES cc_status(nsuk)
  CONSTRAINT cc_head_fk


  ;

update cc_detail set product_type = null where product_type not in (select nsuk from product_type);
ALTER TABLE cc_detail
 ADD constraint foreign key (product_type)
  REFERENCES product_type(nsuk)
  CONSTRAINT cc_detail_fk1


  ;

--update cc_detail set cc_head = null where cc_head not in (select nsuk from cc_head);
--ALTER TABLE cc_detail
 --ADD constraint foreign key (cc_head)
  --REFERENCES cc_head(nsuk)
  --CONSTRAINT cc_detail_fk


--  ;
update cash set lodgement = (select minlodge from t_minlodge)  where lodgement not in (select cod from lodgement);
ALTER TABLE cash
 ADD constraint foreign key (lodgement)
  REFERENCES lodgement(cod)
  CONSTRAINT cash_fk4


  ;

update cash set cash_ac = null where cash_ac not in (select cod from nominal);
ALTER TABLE cash
 ADD constraint foreign key (cash_ac)
  REFERENCES nominal(cod)
  CONSTRAINT cash_fk3


  ;

update cash set operator = 1 where operator not in (select cod from operator);
ALTER TABLE cash
 ADD constraint foreign key (operator)
  REFERENCES operator(cod)
  CONSTRAINT cash_fk2


  ;

update cash set nominal = null where nominal not in (select cod from nominal);
ALTER TABLE cash
 ADD constraint foreign key (nominal)
  REFERENCES nominal(cod)
  CONSTRAINT cash_fk1


  ;
select NSUK froM bin_location
where parent not in (select nsuk from bin_location)
into temp bastard_bins;
update bin_location set parent = null
where nsuk in (select nsuk from bastard_bins);

ALTER TABLE bin_location
 ADD constraint foreign key (parent)
  REFERENCES bin_location(nsuk)
  CONSTRAINT bin_location_fk1


  ;

update barcode set supplier = null where supplier not in (select cod from supplier);
ALTER TABLE barcode
 ADD constraint foreign key (supplier)
  REFERENCES supplier(cod)
  CONSTRAINT barcode_fk1


  ;

delete from barcode where product_type not in (select nsuk from product_type);
ALTER TABLE barcode
 ADD constraint foreign key (product_type)
  REFERENCES product_type(nsuk)
  CONSTRAINT barcode_fk


  ;

update bank_accounts set currency_id = 'EUR' where currency_id not in (select cod from currency);
ALTER TABLE bank_accounts
 ADD constraint foreign key (currency_id)
  REFERENCES currency(cod)
  CONSTRAINT bank_accounts_fk1


  ;

delete from bank_accounts where cod not in (select cod from nominal);
ALTER TABLE bank_accounts
 ADD constraint foreign key (cod)
  REFERENCES nominal(cod)
  CONSTRAINT bank_accounts_fk


  ;

update asset_reg set nominal_plondi = null where nominal_plondi not in (select cod from nominal);
ALTER TABLE asset_reg
 ADD constraint foreign key (nominal_plondi)
  REFERENCES nominal(cod)
  CONSTRAINT asset_reg_fk4


  ;

update asset_reg set nominal_disposals = null where nominal_disposals not in (select cod from nominal);
ALTER TABLE asset_reg
 ADD constraint foreign key (nominal_disposals)
  REFERENCES nominal(cod)
  CONSTRAINT asset_reg_fk3


  ;

update asset_reg set nominal_depn_exp = null where nominal_depn_exp not in (select cod from nominal);
ALTER TABLE asset_reg
 ADD constraint foreign key (nominal_depn_exp)
  REFERENCES nominal(cod)
  CONSTRAINT asset_reg_fk2


  ;

update asset_reg set nominal_accum_depn = null where nominal_accum_depn not in (select cod from nominal);
ALTER TABLE asset_reg
 ADD constraint foreign key (nominal_accum_depn)
  REFERENCES nominal(cod)
  CONSTRAINT asset_reg_fk1


  ;

update asset_reg set nominal_cost = null where nominal_cost not in (select cod from nominal);
ALTER TABLE asset_reg
 ADD constraint foreign key (nominal_cost)
  REFERENCES nominal(cod)
  CONSTRAINT asset_reg_fk


  ;

update unmatched_history set location = null where location not in (select cod from depot);
ALTER TABLE unmatched_history
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT unmatched_history_fk2


  ;

update unmatched set location = null where location not in (select cod from depot);
ALTER TABLE unmatched
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT unmatched_fk2


  ;

update stock_movement set loc_after = null where loc_after not in (select cod from depot);
ALTER TABLE stock_movement
 ADD constraint foreign key (loc_after)
  REFERENCES depot(cod)
  CONSTRAINT stock_movement_fk4


  ;

update stock_movement set loc_before = null where loc_before not in (select cod from depot);
ALTER TABLE stock_movement
 ADD constraint foreign key (loc_before)
  REFERENCES depot(cod)
  CONSTRAINT stock_movement_fk3


  ;

update stock_movement set depot_after = null where depot_after not in (select cod from depot);
ALTER TABLE stock_movement
 ADD constraint foreign key (depot_after)
  REFERENCES depot(cod)
  CONSTRAINT stock_movement_fk2


  ;

update stock_movement set depot_before = null where depot_before not in (select cod from depot);
ALTER TABLE stock_movement
 ADD constraint foreign key (depot_before)
  REFERENCES depot(cod)
  CONSTRAINT stock_movement_fk1


  ;

update stock_location set depot = null where depot not in (select cod from depot);
ALTER TABLE stock_location
 ADD constraint foreign key (depot)
  REFERENCES depot(cod)
  CONSTRAINT stock_location_fk


  ;

update stock_freeze set depot = null where depot not in (select cod from depot);
ALTER TABLE stock_freeze
 ADD constraint foreign key (depot)
  REFERENCES depot(cod)
  CONSTRAINT stock_freeze_fk2


  ;

update stock_accrual set location = null where location not in (select cod from depot);
ALTER TABLE stock_accrual
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT stock_accrual_fk


  ;

update stock set location = null where location not in (select cod from depot);
ALTER TABLE stock
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT stock_fk1


  ;

update stk_take_wrk set location = null where location not in (select cod from depot);
ALTER TABLE stk_take_wrk
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT stk_take_wrk_fk


  ;

update stk_header set depot = null where depot not in (select cod from depot);
ALTER TABLE stk_header
 ADD constraint foreign key (depot)
  REFERENCES depot(cod)
  CONSTRAINT stk_header_fk


  ;

update stk_freeze_dtl set location = null where location not in (select cod from depot);
ALTER TABLE stk_freeze_dtl
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT stk_freeze_dtl_fk


  ;

update so_head set location = null where location not in (select cod from depot);
ALTER TABLE so_head
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT so_head_fk


  ;

update sledger set location = null where location not in (select cod from depot) and location is not null;
ALTER TABLE sledger
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT sledger_fk1


  ;

update pt_serial set location = null where location not in (select cod from depot);
ALTER TABLE pt_serial
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT pt_serial_fk2


  ;

update pstock_history set location = null where location not in (select cod from depot);
ALTER TABLE pstock_history
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT pstock_history_fk1


  ;

update pstock set location = null where location not in (select cod from depot);
ALTER TABLE pstock
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT pstock_fk1


  ;

update pohanal set location = null where location not in (select cod from depot);
ALTER TABLE pohanal
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT pohanal_fk


  ;

update po_head set location = null where location not in (select cod from depot);
ALTER TABLE po_head
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT po_head_fk2


  ;

update pmoves set to_loc = null where to_loc not in (select cod from depot);
ALTER TABLE pmoves
 ADD constraint foreign key (to_loc)
  REFERENCES depot(cod)
  CONSTRAINT pmoves_fk4


  ;

update pmoves set location = null where location not in (select cod from depot);
ALTER TABLE pmoves
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT pmoves_fk1


  ;

delete from pavail where location not in (select cod from depot);
ALTER TABLE pavail
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT pavail_fk1


  ;

update nltrans set location = null where location not in (select cod from depot);
ALTER TABLE nltrans
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT nltrans_fk2


  ;

update nlbatch set location = null where location not in (select cod from depot);
ALTER TABLE nlbatch
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT nlbatch_fk1


  ;

update lodgement set location = null where location not in (select cod from depot);
ALTER TABLE lodgement
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT lodgement_fk


  ;

update journals set location = null where location not in (select cod from depot);
ALTER TABLE journals
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT journals_fk1


  ;

update hmhead set location = null where location not in (select cod from depot);
ALTER TABLE hmhead
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT hmhead_fk


  ;

update gi_head set location = null where location not in (select cod from depot);
ALTER TABLE gi_head
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT gi_head_fk2


  ;

update gi_detail set location = null where location not in (select cod from depot);
ALTER TABLE gi_detail
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT gi_detail_fk7


  ;

update cc_head set location = null where location not in (select cod from depot);
ALTER TABLE cc_head
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT cc_head_fk4


  ;

update disposals set location = null where location not in (select cod from depot);
ALTER TABLE disposals
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT disposals_fk3


  ;

update cust_order set location = null where location not in (select cod from depot);
ALTER TABLE cust_order
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT cust_order_fk


  ;

update cust set location = null where location not in (select cod from depot);
ALTER TABLE cust
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT cust_fk4


  ;

update cr_activity set depot = null where depot not in (select cod from depot);
ALTER TABLE cr_activity
 ADD constraint foreign key (depot)
  REFERENCES depot(cod)
  CONSTRAINT cr_activity_fk2


  ;

update cash set location = null where location not in (select cod from depot);
ALTER TABLE cash
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT cash_fk


  ;

update bin_location set location = null where location not in (select cod from depot);
ALTER TABLE bin_location
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT bin_location_fk


  ;

update phistory set depot = null where depot not in (select cod from depot);
ALTER TABLE phistory
 ADD constraint foreign key (depot)
  REFERENCES depot(cod)
  CONSTRAINT phistory_fk2


  ;

update phistory set location = null where location not in (select cod from depot);
ALTER TABLE phistory
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT phistory_fk1


  ;

update iddetail set ac_location = null where ac_location not in (select cod from depot);
ALTER TABLE iddetail
 ADD constraint foreign key (ac_location)
  REFERENCES depot(cod)
  CONSTRAINT iddetail_fk4


  ;

update iddetail set location = null where location not in (select cod from depot);
ALTER TABLE iddetail
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT iddetail_fk3


  ;

update ihdetail set location = null where location not in (select cod from depot);
ALTER TABLE ihdetail
 ADD constraint foreign key (location)
  REFERENCES depot(cod)
  CONSTRAINT ihdetail_fk2


  ;

update ihdetail set ac_location = null where ac_location not in (select cod from depot);
ALTER TABLE ihdetail
 ADD constraint foreign key (ac_location)
  REFERENCES depot(cod)
  CONSTRAINT ihdetail_fk1


  ;

delete from account_groups where slave_depot not in (select cod from depot);
ALTER TABLE account_groups
 ADD constraint foreign key (slave_depot)
  REFERENCES depot(cod)
  CONSTRAINT account_groups_fk1


  ;

delete from account_groups where master_depot not in (select cod from depot);
ALTER TABLE account_groups
 ADD constraint foreign key (master_depot)
  REFERENCES depot(cod)
  CONSTRAINT account_groups_fk


  ;

update cust set depot = 1
where depot not in (select cod from depot);
ALTER TABLE cust
 ADD constraint foreign key (depot)
  REFERENCES depot(cod)
  CONSTRAINT cust_fk1


  ;

update support set depot = null, cust = null where depot || cust  not in (select depot || cod from  cust);
ALTER TABLE support
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT support_fk


  ;

update stock_movement set cust_depot = null, cust_cod = null where cust_depot || cust_cod not in
(select depot || cod from cust);
ALTER TABLE stock_movement
 ADD constraint foreign key (cust_depot, cust_cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT stock_movement_fk6


  ;

update so_head set depot = null, cust = null where depot || cust not in (select depot || cod from cust);
ALTER TABLE so_head
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT so_head_fk1


  ;

delete from sledger_query where depot || cod  not in (select depot || cod from cust);
delete from sledger_query where sledger not in (select ser from sledger);
ALTER TABLE sledger_query
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT sledger_query_fk1


  ;

update sallocper set acdepot = null, cust = null where acdepot || cust not in (select depot || cod from cust);
ALTER TABLE sallocper
 ADD constraint foreign key (acdepot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT sallocper_fk1


  ;

update pmoves set depot = null, cust = null where depot || cust not in (select depot || cod from cust);
ALTER TABLE pmoves
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT pmoves_fk2


  ;

update phistory set depot = null, cust = null where depot || cust not in (select depot || cod from cust);
ALTER TABLE phistory
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT phistory_fk4


  ;

update ioh_sale set ac_location = null, cust = null where ac_location || cust not in (select depot || cod from cust);
ALTER TABLE ioh_sale
 ADD constraint foreign key (ac_location, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT ioh_sale_fk


  ;

update ioh_hire set ac_location = null, cust = null where ac_location || cust not in (select depot || cod from cust);
ALTER TABLE ioh_hire
 ADD constraint foreign key (ac_location, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT ioh_hire_fk


  ;

update ioh_disp set ac_location = null, cust = null where ac_location || cust not in (select depot || cust from cust);
ALTER TABLE ioh_disp
 ADD constraint foreign key (ac_location, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT ioh_disp_fk


  ;

update inv_details set ac_location = null, cust = null where ac_location || cust not in (select depot || cod from cust);
ALTER TABLE inv_details
 ADD constraint foreign key (ac_location, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT inv_details_fk


  ;

update ihead set ac_location = null where ac_location || cust not in (select depot || cod from cust);
ALTER TABLE ihead
 ADD constraint foreign key (ac_location, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT ihead_fk


  ;

update hmhead set depot = null, cust = null where depot || cust not in (select depot || cod from cust);
ALTER TABLE hmhead
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT hmhead_fk2


  ;

delete from csuspend where depot || cod not in (select depot || cod from cust);
ALTER TABLE csuspend
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT csuspend_fk


  ;

delete from csearch where depot || cod not in (select depot || cod  from cust);
ALTER TABLE csearch
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT csearch_fk


  ;

update contract_suspend set depot = null, cust  = null where depot || cust  not in (select depot || cod from cust);
ALTER TABLE contract_suspend
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT contract_suspend_fk


  ;

delete from  contact where depot || cod not in (select depot || cod from cust);
ALTER TABLE contact
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT contact_fk1


  ;

update disposals set depot =  null, cust = null where depot || cust not in (select depot || cod from cust);
ALTER TABLE disposals
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT disposals_fk2


  ;

delete from custlist where depot || cust not in (select depot || cod from cust);
ALTER TABLE custlist
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT custlist_fk


  ;

update cust_order set depot = null, customer = null where depot || customer not in (select depot || cod from cust);
ALTER TABLE cust_order
 ADD constraint foreign key (depot, customer)
  REFERENCES cust(depot, cod)
  CONSTRAINT cust_order_fk1


  ;

update cr_activity set ac_location = null, ac_code = null where ac_location || ac_code not in (select depot || cod from cust);
ALTER TABLE cr_activity
 ADD constraint foreign key (ac_location, ac_code)
  REFERENCES cust(depot, cod)
  CONSTRAINT cr_activity_fk1


  ;

delete from chead where depot || cust not in (select depot || cod from cust);
ALTER TABLE chead
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT chead_fk


  ;

update chdetail set depot = null, cust = null where depot || cust not in (select depot || cod from cust);
ALTER TABLE chdetail
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT chdetail_fk1


  ;

delete  from account_groups where slave_depot || slave_cust not in (select depot || cod from cust);
ALTER TABLE account_groups
 ADD constraint foreign key (slave_depot, slave_cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT account_groups_fk3


  ;

delete from account_groups where master_depot || master_cust not in (select depot || cod from cust);
ALTER TABLE account_groups
 ADD constraint foreign key (master_depot, master_cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT account_groups_fk2


  ;

delete from  custsite where depot || cust not in (select depot || cod from cust);
ALTER TABLE custsite
 ADD constraint foreign key (depot, cust)
  REFERENCES cust(depot, cod)
  CONSTRAINT custsite_fk


  ;

delete  from custid where depot || cod not in (select depot || cod from cust);
ALTER TABLE custid
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT custid_fk


  ;

delete from cust_query where depot || cod  not in (select depot || cod from cust);
ALTER TABLE cust_query
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT cust_query_fk


  ;

delete from cust_pricelist where depot || cod not in (select depot || cod from cust);
ALTER TABLE cust_pricelist
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT cust_pricelist_fk


  ;

delete from cust_discstruct where depot || cod not in (select depot || cod from cust);
ALTER TABLE cust_discstruct
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT cust_discstruct_fk


  ;

delete from cust_category where depot || cod not in (select depot || cod from cust);
ALTER TABLE cust_category
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT cust_category_fk


  ;

delete from cust_ext where depot || cod not in (select depot || cod from cust);
ALTER TABLE cust_ext
 ADD constraint foreign key (depot, cod)
  REFERENCES cust(depot, cod)
  CONSTRAINT cust_ext_fk


  ;

--delete from  sledger where depot || cod not in (select depot || cod from cust);
--ALTER TABLE sledger
 --ADD constraint foreign key (depot, cod)
  --REFERENCES cust(depot, cod)
  --CONSTRAINT sledger_fk


--  ;

--update pt_ysales set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE pt_ysales
 --ADD constraint foreign key (barcode)
  --REFERENCES barcode(ean)
  --CONSTRAINT pt_ysales_fk


  --;

--update pt_wsales set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE pt_wsales
 --ADD constraint foreign key (barcode)
  --REFERENCES barcode(ean)
  --CONSTRAINT pt_wsales_fk


--  ;

--update pt_msales set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE pt_msales
 --ADD constraint foreign key (barcode)
  --REFERENCES barcode(ean)
  --CONSTRAINT pt_msales_fk
  --

  --;
--
--update product set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE product
 --ADD constraint foreign key (barcode)
  --REFERENCES barcode(ean)
  --CONSTRAINT product_fk4
  --
  --
  --;
----
--update ioh_sale set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE ioh_sale
 --ADD constraint foreign key (barcode)
  --REFERENCES barcode(ean)
  --CONSTRAINT ioh_sale_fk3


  --;

--update iodetail set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE iodetail
 --ADD constraint foreign key (barcode)
  --REFERENCES barcode(ean)
  --CONSTRAINT iodetail_fk4
  --

  --;
--
--update codetail set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE codetail
 --ADD constraint foreign key (barcode)
  --REFERENCES barcode(ean)
  --CONSTRAINT codetail_fk1
  --

  --;

--update driver set barcode = null where barcode not in (select ean from barcode);
--ALTER TABLE driver
 --ADD constraint foreign key (asset_reg)
  --REFERENCES asset_reg(cod)
  --CONSTRAINT driver_fk
  --

  --;

update dispxref set asset_reg = 'H' where asset_reg not in (select cod from asset_reg);
ALTER TABLE dispxref
 ADD constraint foreign key (asset_reg)
  REFERENCES asset_reg(cod)
  CONSTRAINT dispxref_fk


  ;

update disposals set asset_reg = null where asset_reg not in (select cod from asset_reg);
ALTER TABLE disposals
 ADD constraint foreign key (asset_reg)
  REFERENCES asset_reg(cod)
  CONSTRAINT disposals_fk


  ;

update pdesc set asset_reg = null where asset_reg not in (select cod from asset_reg);
ALTER TABLE pdesc
 ADD constraint foreign key (asset_reg)
  REFERENCES asset_reg(cod)
  CONSTRAINT pdesc_fk


  ;

update singles set asset_reg = null where asset_reg not in (select cod from asset_reg);
ALTER TABLE singles
 ADD constraint foreign key (asset_reg)
  REFERENCES asset_reg(cod)
  CONSTRAINT singles_fk


  ;

delete from sledger_query where sledger not in (select ser from sledger);
ALTER TABLE sledger_query
 ADD constraint foreign key (sledger)
  REFERENCES sledger(ser)
  CONSTRAINT sledger_query_fk


  ;

delete from sallocer where er not in (select ser from sledger);

ALTER TABLE sallocer
 ADD constraint foreign key (er)
  REFERENCES sledger(ser)
  CONSTRAINT sallocer_fk1


  ;

delete from sallocee where ee not in (select ser from sledger);
ALTER TABLE sallocee
 ADD constraint foreign key (ee)
  REFERENCES sledger(ser)
  CONSTRAINT sallocee_fk1


  ;
alter table product_type drop constraint u642_1397;
delete from product_type where product not in (select nsuk from product);
-- 0 okay
ALTER TABLE product_type ADD constraint foreign key (product)  REFERENCES product(nsuk)      CONSTRAINT product_type_fk ;
alter table product_type add constraint primary key (nsuk);
update statistics;
